/**
 * 
 */
package cz.cvut.ok.kapo.paa.utils;

import java.util.Collection;
import java.util.Comparator;
import java.util.PriorityQueue;
import java.util.SortedSet;

/**
 * Rozsireni prioritni fronty o citac push-pop -u.
 * @author karel
 *
 */
public class MyPriorityQueue<E> extends PriorityQueue<E> implements MyQueue<E>{
	private int inserts, removes;
	/**
	 * 
	 */
	private static final long serialVersionUID = 173141136131288018L;

	/**
	 * 
	 */
	public MyPriorityQueue() {
		super();
		this.inserts=0;
		this.removes=0;
	}

	/**
	 * @param arg0
	 */
	public MyPriorityQueue(int arg0) {
		super(arg0);
		this.inserts=0;
		this.removes=0;
	}

	/**
	 * @param arg0
	 * @param arg1
	 */
	public MyPriorityQueue(int arg0, Comparator<E> arg1) {
		super(arg0, arg1);
		this.inserts=0;
		this.removes=0;
	}

	/**
	 * @param arg0
	 */
	public MyPriorityQueue(Collection<E> arg0) {
		super(arg0);
		this.inserts=0;
		this.removes=0;
	}

	/**
	 * @param arg0
	 */
	public MyPriorityQueue(PriorityQueue<E> arg0) {
		super(arg0);
		this.inserts=0;
		this.removes=0;
	}

	/**
	 * @param arg0
	 */
	public MyPriorityQueue(SortedSet<E> arg0) {
		super(arg0);
		this.inserts=0;
		this.removes=0;
	}

// ============================= nove metody =================
	/**
	 * @return Returns the inserts.
	 */
	public int getInserts() {
		return inserts;
	}

	/**
	 * @return Returns the removes.
	 */
	public int getRemoves() {
		return removes;
	}
//	 ================ pretizeni metod ========================


	/* (non-Javadoc)
	 * @see java.util.PriorityQueue#add(E)
	 */
	@Override
	public boolean add(E arg0) {
		//this.inserts++;
		return super.add(arg0);
	}

	/* (non-Javadoc)
	 * @see java.util.PriorityQueue#offer(E)
	 */
	@Override
	public boolean offer(E arg0) {
		this.inserts++;
		return super.offer(arg0);
	}

	/* (non-Javadoc)
	 * @see java.util.PriorityQueue#poll()
	 */
	@Override
	public E poll() {
		this.removes++;
		return super.poll();
	}

	/* (non-Javadoc)
	 * @see java.util.PriorityQueue#remove(java.lang.Object)
	 */
	@Override
	public boolean remove(Object arg0) {
		this.removes++;
		return super.remove(arg0);
	}
	
	

}
